
#include "CharaClass.h"
int getpixel(SDL_Surface *surface, int x, int y)
{
    	if(x<0||x>VIDEO_W)return 0xff;
    	if(y<0||y>VIDEO_H)return 0xff;
    	int bpp = surface->format->BytesPerPixel;
    	/* $B$3$N(B p $B$O<hF@$7$?$$%T%/%;%k$r;X$9%"%I%l%9(B */
    	Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    	switch(bpp) {
    		case 1:
        	return *p;

	case 2:
        	return *(Uint16 *)p;
    	case 3:
        	if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            		return p[0] << 16 | p[1] << 8 | p[2];
        	else
            		return p[0] | p[1] << 8 | p[2] << 16;

    	case 4:
        	return *(Uint32 *)p;

    	default:
        	return 0;       /* $B5/$3$k$O$:$,$J$$$,!"%o!<%K%s%0$r2sHr(B */
    }
}
int KeyCheck(int key_flg,int CheckKey)
{
	return key_flg&CheckKey;
}
CChara::CChara()
{
	image.LoadImage("./Images/LINEMAN.bmp");
	image.SetColorKey(0x000000);
	x=110;
	y=-35;
	anime.x=0*ANIME_SPEED;
	anime.y=0*ANIME_SPEED;
	BeforeKeyTime=0;
	JumpSpeed=0;
	JumpFlg=0;
	DashDelay=0;
	DamegeFlg=0;
	Jump2Flg=0;
	MoveFlg=0;
	AttkFlg=0;
	AutFallTime=3;
	MoveSpeed=0;
	invincible=100;
	AfterDashDelay=0;
	life=3;
	for(int i=0;i<BuraMax;i++){
		motion[i].anime=anime;
		motion[i].x=x;
		motion[i].y=y;
	}
}

void CChara::UpDate(SDL_Surface *screen,SDL_Surface *mapimage,int *map_x,int key_flg,int* EndFlg)
{
	int xSpeed=0;
	// $B%@%a!<%8(B
	if(DamegeFlg==2){
		anime.x=9*ANIME_SPEED;
		anime.y=1*ANIME_SPEED;
		DamegeFlg=1;
		life--;
		if(life<0)*EndFlg=1;
	}
	if(DamegeFlg==1){
		anime.x+=2;
		if(anime.x==13*ANIME_SPEED){
				DamegeFlg=0;
				x=110;
				y=-35;
				JumpFlg=1;
				JumpTime=0;
				JumpSpeed=10;
				MoveFlg=90;
				invincible=MoveFlg+70;
				// $B%"%K%a!<%7%g%s@_Dj(B
				anime.x=13*ANIME_SPEED;
				anime.y=0*ANIME_SPEED;
		}
		return;
	}else{
		if(MoveFlg>0)MoveFlg--;
	}
	
	/*// $B%S!<%`(B
	if(KeyCheck(key_flg,UKEY_X) && MoveFlg==0){
		anime.x=13*ANIME_SPEED;
		anime.y=7*ANIME_SPEED;
		beam.CreateBeam(x+CHARA_W,y);
	}
	if(beam.FireFlg==1){
		anime.x+=3;
		if(15*ANIME_SPEED<anime.x)anime.x=15*ANIME_SPEED;
	}
	*/
	
	// $B1&0\F0(B
	if(KeyCheck(key_flg,UKEY_RIGHT) && DashDelay==0&&MoveFlg==0 && beam.FireFlg==0){
		for(int i=0;i<3;i++)
		{
			int flg=0;
			for(int m=0;m<CHARA_H;m++){
				int color=0x000000ff;
				color=getpixel(mapimage,x+xSpeed+CHARA_W,y+m);
				if(color!=0x000000ff){
					flg=1;
					break;
				}
			}
			if(flg==1)break;
			xSpeed++;
		}
		if(JumpFlg==0){
			anime.x+=2;
			// $B%"%K%a!<%7%g%s@_Dj(B
			anime.y=0*ANIME_SPEED;
			if(anime.x>4*ANIME_SPEED)anime.x=0*ANIME_SPEED;
		}
	}
	// $B%8%c%s%W$7$F$J$$$H$-$@$1(B
	if(JumpFlg==0){
		// $BMn2<=hM}(B
		int fall_flg=0;
		for(int m=0;m<CHARA_W;m++){
			int color=0x000000ff;
			color=getpixel(mapimage,x+m,y+CHARA_H);
			if(color!=0x000000ff){
				fall_flg=1;
				break;
			}
		}
		if(fall_flg==0){
			AutFallTime+=0.01f;
			for(int i=0;i<(int)(AutFallTime*2.8f);i++)
			{
				int flg=0;
				for(int m=0;m<CHARA_W;m++){
					int color=0x000000ff;
					color=getpixel(mapimage,x+m,y+CHARA_H);
					if(color!=0x000000ff){
						anime.x=13*ANIME_SPEED;
						JumpFlg=0;
						JumpTime=0;
						JumpSpeed=0;
						Jump2Flg=0;
						flg=1;
					}
				}
				if(flg)break;
				y++;
			}
		}else{
			AutFallTime=3;
		}
	}
	
	// $B%8%c%s%W(B
	if( JumpFlg==0&&MoveFlg==0 && beam.FireFlg==0){
		if( KeyCheck(key_flg,UKEY_UP) ){
			JumpSpeed+=1.5f;
			if(JumpSpeed>6){
				JumpFlg=1;
				JumpTime=0;
				// $B%"%K%a!<%7%g%s@_Dj(B
				anime.x=13*ANIME_SPEED;
				anime.y=0*ANIME_SPEED;
				
			}
		}else if( JumpSpeed>0 ){
			JumpFlg=1;
			JumpTime=0;
			// $B%"%K%a!<%7%g%s@_Dj(B
			anime.x=13*ANIME_SPEED;
			anime.y=0*ANIME_SPEED;
		}
	}
	
	// $BMn2<=hM}(B
	if(((JumpFlg==1 || JumpFlg==2)) && beam.FireFlg==0 ){
		JumpSpeed-=JumpTime*2.8f;
		JumpTime+=0.01f;
		// $B>e>:Cf(B
		if(JumpSpeed>0){
			anime.x++;
			if(anime.x>14*ANIME_SPEED)anime.x=14*ANIME_SPEED;
			anime.y=0*ANIME_SPEED;
		}else if(JumpSpeed<0){
			anime.x++;
			if(anime.x>16*ANIME_SPEED)anime.x=16*ANIME_SPEED;
			anime.y=0*ANIME_SPEED;
			
		}
		
 		SDL_LockSurface( screen );
		for(int i=0;i<abs((int)JumpSpeed);i++)
		{
			
			int flg=0;
			for(int m=0;m<CHARA_W;m++){
				int color=0x000000ff;
				if(JumpSpeed<0){
					color=getpixel(mapimage,x+xSpeed+m,y+CHARA_H+1);
					if(color!=0x000000ff){
						anime.x=13*ANIME_SPEED;
						JumpFlg=0;
						JumpTime=0;
						JumpSpeed=0;
						Jump2Flg=0;
						flg=1;
					}
				}else{
					color=getpixel(mapimage,x+xSpeed+m,y);
					if(color!=0x000000ff){
						JumpTime=1;
						flg=1;
					}
				}
				
			}
			if(flg)break;
			if(JumpSpeed>0){y--;}else{y++;}
		}
    		SDL_UnlockSurface( screen );
	}
	
	// $B#2CJ%8%c%s%W(B
	if(JumpFlg==1 && !KeyCheck(key_flg,UKEY_UP&&MoveFlg==0))Jump2Flg=1;
	if(JumpFlg==1 && JumpTime>0.08f && KeyCheck(key_flg,UKEY_UP) && Jump2Flg==1){
		JumpSpeed=6;
		JumpTime=0;
		JumpFlg=2;
		// $B%"%K%a!<%7%g%s@_Dj(B
		anime.x=13*ANIME_SPEED;
		anime.y=0*ANIME_SPEED;
	}
	
	// $B%@%C%7%e(B
	if(KeyCheck(key_flg,UKEY_RIGHT)&&MoveFlg==0 && beam.FireFlg==0 && AfterDashDelay==0){
		if(BeforeKeyTime<100 && BeforeKeyTime>93 && DashDelay==0){
			DashDelay=17;
			anime.x=6*ANIME_SPEED;
			anime.y=7*ANIME_SPEED;
			}
		BeforeKeyTime=100;
	}else{
		BeforeKeyTime--;
	}
	
	if(DashDelay>0){
		for(int i=0;i<5;i++)
		{
			int flg=0;
			for(int m=0;m<CHARA_H;m++){
				int color=0x000000ff;
				color=getpixel(mapimage,x+xSpeed+CHARA_W,y+m);
				if(color!=0x000000ff){
					flg=1;
					break;
				}
			}
			if(flg==1)break;
			xSpeed++;
		}
		DashDelay--;
		anime.x++;
		anime.y=7*ANIME_SPEED;
		if(anime.x>9*ANIME_SPEED)anime.x=6*ANIME_SPEED;
		if(DashDelay==1){
			anime.x=10*ANIME_SPEED;
			anime.y=7*ANIME_SPEED;
		}else if(DashDelay==0){
			anime.x=0*ANIME_SPEED;
			anime.y=0*ANIME_SPEED;
			AfterDashDelay=40;
		}
	}
	if(AfterDashDelay>0)AfterDashDelay--;
	
	// $B%V%i!<@_Dj(B
	for(int i=0;i<BuraMax-1;i++){
		motion[i].anime=motion[i+1].anime;
		motion[i].x=motion[i+1].x-xSpeed;
		motion[i].y=motion[i+1].y;
	}
	motion[BuraMax-1].anime=anime;
	motion[BuraMax-1].x=x-xSpeed;
	motion[BuraMax-1].y=y;
	
	// $BL5E(;~4V(B
	invincible--;
	if(invincible<0)invincible=0;
	// $B%^%C%W0\F0NL7W;;(B
	*map_x+=xSpeed;
	MoveSpeed=xSpeed;
}

void CChara::Draw(SDL_Surface *screen)
{
	int color=0;
	// $B%-%c%i%V%i!<(B
	if( (DashDelay>0 || JumpFlg!=0 ) && MoveFlg==0){
		for(int i=0;i<BuraMax;i++){
			SDL_SetAlpha(image.image,SDL_SRCALPHA,(int)(200/(BuraMax-i)));
			image.Draw(motion[i].x,motion[i].y,(motion[i].anime.x/ANIME_SPEED)*32,(motion[i].anime.y/ANIME_SPEED)*32,32,32,screen);
		}
	}
	SDL_SetAlpha(image.image,SDL_SRCALPHA,255);
	// $B%-%c%iK\BN(B
	if(invincible==0||invincible%2==0||DashDelay!=0){
	image.Draw(x,y,(anime.x/ANIME_SPEED)*32,(anime.y/ANIME_SPEED)*32,32,32,screen);
	}
	beam.DrawBeam(screen);
	//char str[256];xSpeed
	//sprintf(str,"x=%d y=%d",x,y);
	//SDL_WM_SetCaption(str,NULL);
}
