#include "GameBase.h"
#include "Common.h"
void fps_no();
GameBase::GameBase()
{
	EndFlg=0;
	key_flg = 0x00;
	map_x=0;
	screen=NULL;
	time=100;
	StartImage.LoadImage("./Images/StartImage.bmp");
	font.LoadImage("./Images/font.bmp");
}

GameBase::~GameBase()
{
	// $B%a%b%j3+J|(B
	SDL_FreeSurface(screen);
	// SDL$B$N:G=*=*N;(B(SDL_Init$B$HBP(B)
	SDL_Quit();
}
void GameBase::Start()
{
	SDL_Event	event;
	int flg=1;
	float y=-VIDEO_H;
	float vec=10;
	float mayvec=vec;
	float time=0;
	float h=0.05f;
	int dtime=500;
	while(flg){
		while(SDL_PollEvent(&event)){		// $B%$%Y%s%H$N<hF@(B
			switch(event.type){		// $B%$%Y%s%H$N<oN`(B
				case SDL_QUIT:
					flg=0;
					EndFlg=9;
				case SDL_KEYDOWN:
					if(dtime<=0)flg=0;
					break;
			}
		}
		if(vec!=0){
			time+=0.125f;
			vec-=0.025f*time;
			y-=vec;
		}
		if(y>0){
			time=0;
			mayvec--;
			if(mayvec<0)mayvec=0;
			vec=mayvec;
		}
		StartImage.Draw(0,(int)y,0,0,VIDEO_W,VIDEO_H,screen);
		SDL_Flip(screen);
		if(dtime>0)dtime--;
	}
}
bool GameBase::InitGame()
{
	// SDL$B$N=i4|2=(B
	if(SDL_Init(SDL_INIT_VIDEO)<0){
		return false;
	}

	// $B%"%$%3%s$N@_Dj(B
	SDL_WM_SetIcon(SDL_LoadBMP("p.bmp"),NULL);
	
	// $B%?%$%H%k$N@_Dj(B
	SDL_WM_SetCaption(W_NAME,NULL);
	
	// $B%S%G%*@_Dj(B,$BI=<(%&%#%s%I%&@_Dj(B
	screen=SDL_SetVideoMode(VIDEO_W,VIDEO_H,VIDEO_BIT,SDL_HWSURFACE);
	
	if(screen==NULL){
		return false;
	}
	SDL_ShowCursor(SDL_DISABLE);
	return true;
}

void GameBase::Draw()
{
	map.DrawMap(screen);
	chara.Draw(screen);
	enemy.DrawAllShot(screen);
	DrawNum(10,10,(int)time,5,chara.Get_Life());
	SDL_Flip(screen);
}
void GameBase::UpdateTask()
{
	time-=0.025f;
	if(time<=0)EndFlg=1;
	fps_no();
	map.UpdateMap(map_x);
	enemy.MakeShot(time);
	enemy.MoveAllShot(chara.MoveSpeed);
	hit.HitSystem(&chara,enemy.shot);
	chara.UpDate(screen,map.MapImage(),&map_x,key_flg,&EndFlg);
}
void GameBase::DrawNum(int x,int y,int num,int max_num,int life){
	int n;
	int keta=0;
	
	// $B%?%$%`(B
	if(num<0)num=0;
	font.Draw(8*0+x,y,8*(('t'-96)%16),16+(('t'-96)/16)*8,8,8,screen);
	font.Draw(8*1+x,y,8*(('i'-96)%16),16+(('i'-96)/16)*8,8,8,screen);
	font.Draw(8*2+x,y,8*(('m'-96)%16),16+(('m'-96)/16)*8,8,8,screen);
	font.Draw(8*3+x,y,8*(('e'-96)%16),16+(('e'-96)/16)*8,8,8,screen);
	for(int i=max_num;i>=0;i--){
		n=num/(int)pow(10,i);
		num-=(int)(n*pow(10,i));
		font.Draw(16+32+x+8*keta++,y,8*n,8,8,8,screen);
	}
	
	// $B%F%s%9%&(B
	x+=8*keta+8*4+32;
	num=map_x;
	keta=0;
	font.Draw(8*0+x,y,8*(('s'-96)%16),16+(('s'-96)/16)*8,8,8,screen);
	font.Draw(8*1+x,y,8*(('c'-96)%16),16+(('c'-96)/16)*8,8,8,screen);
	font.Draw(8*2+x,y,8*(('o'-96)%16),16+(('o'-96)/16)*8,8,8,screen);
	font.Draw(8*3+x,y,8*(('r'-96)%16),16+(('r'-96)/16)*8,8,8,screen);
	font.Draw(8*4+x,y,8*(('e'-96)%16),16+(('e'-96)/16)*8,8,8,screen);
	for(int i=max_num;i>=0;i--){
		n=num/(int)pow(10,i);
		num-=(int)(n*pow(10,i));
		font.Draw(16+32+x+8*keta++,y,8*n,8,8,8,screen);
	}
	
	// $B%i%$%U(B
	x+=8*keta+8*4+32;
	num=map_x;
	keta=0;
	font.Draw(8*0+x,y,8*(('l'-96)%16),16+(('l'-96)/16)*8,8,8,screen);
	font.Draw(8*1+x,y,8*(('i'-96)%16),16+(('i'-96)/16)*8,8,8,screen);
	font.Draw(8*2+x,y,8*(('f'-96)%16),16+(('f'-96)/16)*8,8,8,screen);
	font.Draw(8*3+x,y,8*(('e'-96)%16),16+(('e'-96)/16)*8,8,8,screen);
	for(int i=0;i<life;i++){
		font.Draw(x+8*4+8*i+8,y,0,0,8,8,screen);
	}
}
void GameBase::SetKeyStateDown(SDLKey key)
{
	switch(key){
		case SDLK_UP:	key_flg=key_flg|0x1;	break;
		case SDLK_DOWN:	key_flg=key_flg|0x2;	break;
		case SDLK_LEFT:	key_flg=key_flg|0x4;	break;
		case SDLK_RIGHT:key_flg=key_flg|0x8;	break;
		case 'z':key_flg=key_flg|UKEY_Z;	break;
		case 'x':key_flg=key_flg|UKEY_X;	break;
	}			
					
}
void GameBase::SetKeyStateUp(SDLKey key){

	switch(key){
			case SDLK_UP:	key_flg=key_flg&0xFE;	break;
			case SDLK_DOWN:	key_flg=key_flg&0xFD;	break;
			case SDLK_LEFT:	key_flg=key_flg&0xFB;	break;
			case SDLK_RIGHT:key_flg=key_flg&0xF7;	break;
			case 'z':key_flg=key_flg&0xEF;	break;
			case 'x':key_flg=key_flg&0xDF;	break;
		}
}

// $B%U%l!<%`%l!<%H7W;;4X?t(B
void fps_no(){
	static int tick=0;
	static int cnt=0,fps=0;
	static int before_time=0;
	int this_time=0;
	char str[256];
	
	cnt++;
	
	if(tick+1000<SDL_GetTicks()){
		fps=cnt;
		cnt=0;
		tick=SDL_GetTicks();
		// $B%?%$%H%k$N@_Dj(B
		//sprintf(str,"FPS:%3d",fps);
		//SDL_WM_SetCaption(str,NULL);
	}
	
	this_time=SDL_GetTicks();
	float time=this_time-before_time;
	if(time<16.0f){
		SDL_Delay(int(16.0f-time));
	}
	before_time=SDL_GetTicks();
}

void GameBase::End()
{	
	SDL_Event	event;
	int flg=1;
	float y=-VIDEO_H;
	float vec=10;
	float mayvec=vec;
	float time=0;
	float h=0.05f;
	int dtime=600;
	CSprite	EndImage;
	CSprite	NumImage;
	EndImage.LoadImage("./Images/End.bmp");
	NumImage.LoadImage("./Images/num.bmp");
	NumImage.SetColorKey(0x000000);
	while(flg){
		while(SDL_PollEvent(&event)){		// $B%$%Y%s%H$N<hF@(B
			switch(event.type){		// $B%$%Y%s%H$N<oN`(B
				case SDL_QUIT:
					flg=9;
				case SDL_KEYDOWN:
					if(dtime<=0){
					switch(event.key.keysym.sym){
						case SDLK_r:	EndFlg=0;break;
						case SDLK_e:	EndFlg=9;break;
					}
					}
					break;
			}
		}
		if(vec!=0){
			time+=0.125f;
			vec-=0.025f*time;
			y-=vec;
		}
		if(y>0){
			time=0;
			mayvec--;
			if(mayvec<0)mayvec=0;
			vec=mayvec;
		}
		EndImage.Draw(0,(int)y,0,0,VIDEO_W,VIDEO_H,screen);
		int num=map_x;
		int n;
		NumImage.Draw(60,100+(int)y,215,0,120,32,screen);
		for(int i=5;i>=0;i--){
			n=num/(int)pow(10,i);
			num-=(int)(n*pow(10,i));
			NumImage.Draw(60+130+21*(5-i),100+(int)y,21*n,0,21,32,screen);
		}
		SDL_Flip(screen);
		if(dtime>0)dtime--;
		if(EndFlg==0 || EndFlg==9)break;
	}
}

