#ifndef __GAME_BASE_CALL__
#define __GAME_BASE_CALL__

#include <SDL/SDL.h>
#include <math.h>
#include "CharaClass.h"
#include "Common.h"
#include "MapClass.h"
#include "SpriteClass.h"
#include "Enemy.h"
#include "HitClass.h"
class GameBase
{
private:
	SDL_Surface	*screen;	// スクリーン用メモリ
	SDL_PixelFormat	*fmt;		// サーフェス色フォーマット格納用(パレット)
	CSprite	StartImage;
	CSprite font;
	int	rgb;			// 塗りつぶし用
	int	map_x;
	float	time;
public:
	GameBase();		// コンストラクタ
	~GameBase();		// デストラクタ
	CChara chara;
	EnemyClass enemy;
	MapClass map;
	HitClass hit;
	int EndFlg;
	SDL_Event	event;	// イベント用構造体
	unsigned char key_flg;	// キーフラグ
	void SetKeyStateDown(SDLKey key);
	void SetKeyStateUp(SDLKey key);
	void UpdateTask();
	void Draw();		// 描画
	void Start();
	void End();
	void DrawNum(int x,int y,int num,int max_num,int life);	// 数値描画
	bool InitGame();	// 初期化
};

#endif
